=begin
#AllQ

#No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

OpenAPI spec version: 1.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.2

=end

require 'date'

module Allq
  # Model for a parent job
  class NewParentJob
    # Tube name
    attr_accessor :tube

    # Text payload
    attr_accessor :body

    # Time to live when reserved (in seconds)
    attr_accessor :ttl

    # Delay before becoming available for processing in seconds
    attr_accessor :delay

    # Priority of job in tube
    attr_accessor :priority

    # Parent job id (if applicable)
    attr_accessor :parent_id

    # Timeout to run
    attr_accessor :timeout

    # Execute job after timeout
    attr_accessor :run_on_timeout

    # Number of children
    attr_accessor :limit

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'tube' => :'tube',
        :'body' => :'body',
        :'ttl' => :'ttl',
        :'delay' => :'delay',
        :'priority' => :'priority',
        :'parent_id' => :'parent_id',
        :'timeout' => :'timeout',
        :'run_on_timeout' => :'run_on_timeout',
        :'limit' => :'limit'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'tube' => :'String',
        :'body' => :'String',
        :'ttl' => :'Integer',
        :'delay' => :'Integer',
        :'priority' => :'Integer',
        :'parent_id' => :'String',
        :'timeout' => :'Integer',
        :'run_on_timeout' => :'BOOLEAN',
        :'limit' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'tube')
        self.tube = attributes[:'tube']
      else
        self.tube = 'default'
      end

      if attributes.has_key?(:'body')
        self.body = attributes[:'body']
      else
        self.body = '<BODY_TEXT>'
      end

      if attributes.has_key?(:'ttl')
        self.ttl = attributes[:'ttl']
      else
        self.ttl = 1200
      end

      if attributes.has_key?(:'delay')
        self.delay = attributes[:'delay']
      else
        self.delay = 0
      end

      if attributes.has_key?(:'priority')
        self.priority = attributes[:'priority']
      else
        self.priority = 5
      end

      if attributes.has_key?(:'parent_id')
        self.parent_id = attributes[:'parent_id']
      end

      if attributes.has_key?(:'timeout')
        self.timeout = attributes[:'timeout']
      end

      if attributes.has_key?(:'run_on_timeout')
        self.run_on_timeout = attributes[:'run_on_timeout']
      else
        self.run_on_timeout = false
      end

      if attributes.has_key?(:'limit')
        self.limit = attributes[:'limit']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @tube.nil?
        invalid_properties.push('invalid value for "tube", tube cannot be nil.')
      end

      if @body.nil?
        invalid_properties.push('invalid value for "body", body cannot be nil.')
      end

      if @ttl.nil?
        invalid_properties.push('invalid value for "ttl", ttl cannot be nil.')
      end

      if @delay.nil?
        invalid_properties.push('invalid value for "delay", delay cannot be nil.')
      end

      if @priority.nil?
        invalid_properties.push('invalid value for "priority", priority cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @tube.nil?
      return false if @body.nil?
      return false if @ttl.nil?
      return false if @delay.nil?
      return false if @priority.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          tube == o.tube &&
          body == o.body &&
          ttl == o.ttl &&
          delay == o.delay &&
          priority == o.priority &&
          parent_id == o.parent_id &&
          timeout == o.timeout &&
          run_on_timeout == o.run_on_timeout &&
          limit == o.limit
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [tube, body, ttl, delay, priority, parent_id, timeout, run_on_timeout, limit].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Allq.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
